//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1   DeepSkyBlue
#property indicator_width1   2
#property indicator_maximum  1.1
#property indicator_minimum -1.1
#property indicator_level1   0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int                 CorrelationPeriod    = 25;
extern int                Ma1Period            = 12;
extern ENUM_APPLIED_PRICE Ma1Price             = PRICE_CLOSE;
extern ENUM_MA_METHOD     Ma1Type              = MODE_SMA;
extern int                Ma2Period            = 26;
extern ENUM_APPLIED_PRICE Ma2Price             = PRICE_CLOSE;
extern ENUM_MA_METHOD     Ma2Type              = MODE_SMA;

double corr[];
double ma1[];
double ma2[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,corr);
   SetIndexBuffer(1,ma1);
   SetIndexBuffer(2,ma2);
   return(0);
}

//
//
//
//
//
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit;i>=0;i--)
   {
      ma1[i]   = iMA(NULL,0,Ma1Period,0,Ma1Type,Ma1Price,i);
      ma2[i]   = iMA(NULL,0,Ma2Period,0,Ma2Type,Ma2Price,i);
      corr[i]  = iCorrelation(ma1,ma2,CorrelationPeriod,i);
   }
   return(0);
}




//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

double iCorrelation(double& first[], double& second[], int length, int i)
{
   double sx  = 0;
   double sy  = 0;
   double sxy = 0;
   double sx2 = 0;
   double sy2 = 0;
            
   for (int k=0; k<length; k++)
   {
      double pricea = first[i+k];
      double priceb = second[i+k];
         sx += pricea; sx2 += pricea*pricea;
         sy += priceb; sy2 += priceb*priceb;
                       sxy += pricea*priceb;
   }
    
   double result  = 0;
   double divisor = MathSqrt(((sx2-(sx*sx)/length)*(sy2-(sy*sy)/length)));
      if (divisor != 0)
               result = (sxy - (sx*sy)/length)/divisor;
   return(result);
}